## ide-completion-types ide-completion-types |

## Properties

GtkTextView * | buffer | Read
guint | n-rows | Read / Write
GtkSourceView * | view | Read / Write / Construct Only
gboolean | busy | Read
IdeCompletion * | completion | Read / Write / Construct Only
gboolean | empty | Read

## Signals

void | hide | Action
void | provider-added | Run Last
void | provider-removed | Run Last
void | show | Action

## Types and Values

enum | IdeCompletionActivation
enum | IdeCompletionColumn
| IdeCompletion
| IdeCompletionContext
| IdeCompletionDisplay
| IdeCompletionProposal
| IdeCompletionProvider

## Object Hierarchy

        GEnum
        ├── IdeCompletionActivation
        ╰── IdeCompletionColumn
        GInterface
        ├── IdeCompletionDisplay
        ├── IdeCompletionProposal
        ╰── IdeCompletionProvider
        GObject
        ├── IdeCompletion
        ╰── IdeCompletionContext

## Prerequisites

IdeCompletionDisplay requires GtkWidget.

IdeCompletionProposal requires GObject.

IdeCompletionProvider requires GObject.

## Implemented Interfaces

IdeCompletionContext implements GListModel.

## Known Implementations

IdeCompletionProposal is implemented by IdeLspCompletionItem.

IdeCompletionProvider is implemented by IdeLspCompletionProvider.

## Description

## Functions

## Types and Values

### enum IdeCompletionActivation

#### Members

IDE_COMPLETION_INTERACTIVE |  |
IDE_COMPLETION_USER_REQUESTED |  |
IDE_COMPLETION_TRIGGERED |  |

### enum IdeCompletionColumn

#### Members

IDE_COMPLETION_COLUMN_ICON |  |
IDE_COMPLETION_COLUMN_LEFT_OF |  |
IDE_COMPLETION_COLUMN_TYPED_TEXT |  |
IDE_COMPLETION_COLUMN_RIGHT_OF |  |

### IdeCompletion

    typedef struct _IdeCompletion IdeCompletion;

### IdeCompletionContext

    typedef struct _IdeCompletionContext IdeCompletionContext;

### IdeCompletionDisplay

    typedef struct _IdeCompletionDisplay IdeCompletionDisplay;

### IdeCompletionProposal

    typedef struct _IdeCompletionProposal IdeCompletionProposal;

### IdeCompletionProvider

    typedef struct _IdeCompletionProvider IdeCompletionProvider;

## Property Details

### The `“buffer”` property

      “buffer”                   GtkTextView *

The GtkTextBuffer for the “view”. This is a convenience property for providers.

Owner: IdeCompletion

Flags: Read

Since: 3.32

### The `“n-rows”` property

      “n-rows”                   guint

The number of rows to display to the user.

Owner: IdeCompletion

Flags: Read / Write

Allowed values: [1,32]

Default value: 5

Since: 3.32

### The `“view”` property

      “view”                     GtkSourceView *

The "view" property is the GtkTextView for which this IdeCompletion is providing completion features.

Owner: IdeCompletion

Flags: Read / Write / Construct Only

Since: 3.32

### The `“busy”` property

      “busy”                     gboolean

The "busy" property is `TRUE` while the completion context is populating completion proposals.

Owner: IdeCompletionContext

Flags: Read

Default value: FALSE

Since: 3.32

### The `“completion”` property

      “completion”               IdeCompletion *

The "completion" is the IdeCompletion that was used to create the context.

Owner: IdeCompletionContext

Flags: Read / Write / Construct Only

Since: 3.32

### The `“empty”` property

      “empty”                    gboolean

The "empty" property is `TRUE` when there are no results.

It will be notified when the first result is added or the last result is removed.

Owner: IdeCompletionContext

Flags: Read

Default value: TRUE

Since: 3.32

## Signal Details

### The `“hide”` signal

    void
    user_function (IdeCompletion *self,
                   gpointer       user_data)

The "hide" signal is emitted when the completion window should be hidden.

#### Parameters

self | an IdeCompletion |
user_data | user data set when the signal handler was connected. |

Flags: Action

Since: 3.32

### The `“provider-added”` signal

    void
    user_function (IdeCompletion         *self,
                   IdeCompletionProvider *provider,
                   gpointer               user_data)

The "provided-added" signal is emitted when a new provider is added to the completion.

#### Parameters

self | an ideCompletion |
provider | an IdeCompletionProvider |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since: 3.32

### The `“provider-removed”` signal

    void
    user_function (IdeCompletion         *self,
                   IdeCompletionProvider *provider,
                   gpointer               user_data)

The "provided-removed" signal is emitted when a provider has been removed from the completion.

#### Parameters

self | an ideCompletion |
provider | an IdeCompletionProvider |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since: 3.32

### The `“show”` signal

    void
    user_function (IdeCompletion *self,
                   gpointer       user_data)

The "show" signal is emitted when the completion window should be shown.

#### Parameters

self | an IdeCompletion |
user_data | user data set when the signal handler was connected. |

Flags: Action

Since: 3.32